Subject: Re: CCL:random number generators

From: TOPPER ROBERT <[email-masked]>
Date: Wed, 15 Mar 1995 12:12:54 -0500

My best advice is to beware of using random number
generators as black-boxes, especially in the context
of Monte Carlo integrations and simulations. 

When using random number generators in Monte Carlo, you
have to not only worry about whether the samples are
uniform on the plane and uncorrelated in hyperdimensions
but also about the period of the random number sequence
(all random number generators, as you know, have a period
for a given seed -
and if your program requires a # of random numbers which
is on the order of the period of the algorithm, better
watch out).  What's more, RNGs which perform perfectly
well against a battery of statistical tests have been
known to fail when used, for example, in 3D Ising lattice
calculations...there is a good bit of literature on this
subject.

I personally wouldn't use any random number generator in 
my Monte Carlo work unless I knew exactly what the algorithm
was, had a reference for it, and had subjected it to my personal
battery of tests, which includes statistical tests ala Knuth
and application tests (path-integral and classical Monte Carlo
computations). At least then, if there is a bug in the
algorithm I know who to blame for all those wasted cycles...

Finally, in every Monte Carlo calculation I have ever carried out,
the limiting factor has not been the speed of the random number
generator, but the evaluation of the potential energy. But then
I've never done QMC calculations, so I don't know what the 
"rate-determining step" is for such calcs. Because of this,
I tend to err on the side of slow, but solid random number generation.

hope this helps, best to all-
rqt

************************************************************************
 Prof. Robert Q. Topper               internet:   [email-masked]
 Department of Chemistry              phone:      (212) 353-4378
 The Cooper Union                     FAX:        (212) 353-4341 
 51 Astor Place                       subway:     take the 6 to Astor Place 
 New York, NY 10003 USA                           or the N/R to 8th St/NYU
************************************************************************
The Cooper Union for the Advancement of Science and Art, established by
Peter Cooper in 1859, is a private institution of higher learning where
all students receive full-tuition scholarships.